/**
 * @package    vBulletin Payment Plugin
 * @author     Hamyar Programming Team
 * @copyright  2010-2014 Mohammad Hossein Abedinpour
 */
$(document).ready(function() {
	$('a').each(function() {
		$(this).attr('target', '_BLANK');
	});
	var elements = document.getElementsByTagName("input");
	for (var i = 0; i < elements.length; i++) {
		elements[i].oninvalid = function(e) {
			e.target.setCustomValidity("");
			if (!e.target.validity.valid) {
				switch($(e.target).attr('id')) {
				case 'hamyar_payment_name':
					e.target.setCustomValidity("لطفا نام خود را به صورت صحیح وارد نمایید.");
					break;
				case 'hamyar_payment_email':
					e.target.setCustomValidity("لطفا ایمیل خود را به صورت صحیح وارد نمایید.");
					break;
				case 'hamyar_payment_phone':
					e.target.setCustomValidity("لطفا شماره همراه خود را به صورت صحیح وارد نمایید.");
					break;
				case 'hamyar_payment_amount':
					e.target.setCustomValidity(window.hamyar_error);
					break;
				}
			}
		};
		elements[i].oninput = function(e) {
			e.target.setCustomValidity("");
		};
	}
	function addCommas(str) {
		var amount = new String(str);
		amount = amount.split("").reverse();

		var output = "";
		for (var i = 0; i <= amount.length - 1; i++) {
			output = amount[i] + output;
			if ((i + 1) % 3 == 0 && (amount.length - 1) !== i)
				output = ',' + output;
		}
		return output;
	}

	function str_replace(search, replace, subject, count) {
		var i = 0, j = 0, temp = '', repl = '', sl = 0, fl = 0, f = [].concat(search), r = [].concat(replace), s = subject, ra = Object.prototype.toString.call(r) === '[object Array]', sa = Object.prototype.toString.call(s) === '[object Array]';
		s = [].concat(s);
		if (count) {
			this.window[count] = 0;
		}

		for ( i = 0, sl = s.length; i < sl; i++) {
			if (s[i] === '') {
				continue;
			}
			for ( j = 0, fl = f.length; j < fl; j++) {
				temp = s[i] + '';
				repl = ra ? (r[j] !== undefined ? r[j] : '') : r[0];
				s[i] = (temp).split(f[j]).join(repl);
				if (count && s[i] !== temp) {
					this.window[count] += (temp.length - s[i].length) / f[j].length;
				}
			}
		}
		return sa ? s : s[0];
	}


	$("#hamyar_payment_amount").keyup(function() {
		$(this).val(addCommas(str_replace(",", "", $(this).val())));
	});
	$('#payment').submit(function() {
		if (!$(this).hasClass('working')) {
			$('#pay').empty().val('در حال ارسال...');
			$(this).addClass('working');
			var formData = new FormData($(this)[0]);
			$.ajax({
				url : 'hamyar_payment.php',
				type : 'POST',
				data : formData,
				cache : false,
				contentType : false,
				processData : false,
				success : function(data) {
					console.log(data);
					try {
						var obj = jQuery.parseJSON(data);
						if (obj[0] == 'ok') {
							$('#pay').empty().val('در حال انتقال به درگاه...');
							$('#payment').removeClass('working');
							eval(obj[1]);
						} else {
							$('#pay').empty().val(obj[1]);
							$('#payment').removeClass('working');
						}
					} catch(e) {
						alert('مشکلی پیش آمد، مجددا تلاش کنید.');
						$('#pay').empty().val('ارسال مبلغ');
						$('#payment').removeClass('working');
						console.log(e);
					}
				}
			}).fail(function(data) {
				alert('مشکلی پیش آمد، مجددا تلاش کنید.');
				$('#pay').empty().val('ارسال مبلغ');
				$('#payment').removeClass('working');
			});
		}
		return false;
	});
});
